unit ScreensaveFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TScreensaveForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  protected
    FirstPos: TPoint;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ScreensaveForm: TScreensaveForm;

implementation

{$R *.DFM}

procedure TScreensaveForm.FormCreate(Sender: TObject);
begin
  HandleNeeded;
  ClientWidth := Screen.Width;
  ClientHeight := Screen.Height;

  GetCursorPos(FirstPos);

  //`@

  ShowCursor(False);
  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, nil, 1);
end;

procedure TScreensaveForm.FormDestroy(Sender: TObject);
begin
  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, nil, 1);
  ShowCursor(True);
end;

procedure TScreensaveForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  Close;
end;

procedure TScreensaveForm.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Close;
end;

procedure TScreensaveForm.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  Close;
end;

procedure TScreensaveForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  nPos: TPoint;

begin
  GetCursorPos(nPos);

  if Abs(nPos.x - FirstPos.x) + Abs(nPos.y - FirstPos.y) <= 4 then Exit;

  Close;
end;

end.

